#include <dos.h>

int _init(unsigned port, unsigned long rate);
unsigned char W_getchar(int port);
void sendchar(int port, unsigned char info);
int comhit(int port);

#define PrT(a,n)  _offsets[(a)]+(n)  // a way to make life a little easier
#define COM1 0    // definitions of stuff
#define COM2 1
#define COM3 2
#define COM4 3


int _init(unsigned port, unsigned long rate)
  {
   unsigned divisor;
   unsigned _offsets[4];

   _offsets[0] = 0X3F8;  // hahah!!!
   _offsets[1] = 0X2F8;
   _offsets[2] = 0X3E8;
   _offsets[3] = 0X2E8;



   // check speed
   if (rate > 115200)
     return(1);
   if (rate == 0)
     return(2);
   // set speed
    // calc divisor
   divisor = 115200/rate;
    // send divisor
     // set divisor input
   outportb(PrT(port,3), 0X80);
     // send divisor
   outport(PrT(port,0), divisor);
   // clear int reg.
    // put the earth back where you got it from, set mode while atit
   outportb(PrT(port,3), 0X03);
    // clear int reg.
   outportb(PrT(port,1), 0);
   // set 8N1
    // already done
   // MCR = 30h
   outportb(PrT(port,4), 0X03);
   return 0;
  }




 unsigned char W_getchar(int port)
  {
   unsigned _offsets[4];

   _offsets[0] = 0X3F8;  // hahah!!!
   _offsets[1] = 0X2F8;
   _offsets[2] = 0X3E8;
   _offsets[3] = 0X2E8;

   // loop until a character ready
    while (!(inportb(PrT(port,5)) & 0X01));
   //return the character
   return(inportb(PrT(port,0)));
  }



 void sendchar(int port, unsigned char info)
  {
   unsigned _offsets[4];

   _offsets[0] = 0X3F8;  // hahah!!!
   _offsets[1] = 0X2F8;
   _offsets[2] = 0X3E8;
   _offsets[3] = 0X2E8;


   // wait for tx buff to be mt
   while (!(inportb(PrT(port,5)) & 0X20));
   // send char to buff
   outportb(PrT(port,0), info);
   return;
  }


 int comhit(int port)
  {
   unsigned _offsets[4];

   _offsets[0] = 0X3F8;  // hahah!!!
   _offsets[1] = 0X2F8;
   _offsets[2] = 0X3E8;
   _offsets[3] = 0X2E8;

   return(inportb(PrT(port,5)) & 0X01);
  }