// remote-o-prompt by dan williams



/*

further ideas:


- a file to hold a list of instructions
- a 'wait for acknowledge' signal


*/
#include <bios.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#define COM1       0
#define COM2       1
#define COM3       2
#define COM4       3
#define DATA_READY 0x100
#define TRUE       1
#define FALSE      0
#define INFILE     2  // If a file is comming in
#define SETTINGS (_COM_2400 | _COM_CHR8 | _COM_STOP1 | _COM_NOPARITY)

#define _done    0   // EOP flag
#define _command 1   // load instruction
#define _recieve 2   // a recieve file
#define _send    3   // a send file
#define _exec    4   // dos command

/*
bla 4 sOCT.POV cPOVIT OCT 320.DEF  // with com 4 send oct.pov and do dos thing
bla 4 rOCT.TGA                     // with com 4 get oct.tga
*/


/* formats of stuff
command:
d(command line string)[0D]
file send:
s(name)(length)(file)
recieve file:
r(name)(length)(file)
*/

FILE* M_open(int direction);


  long fsize;               // a file size variable
  unsigned status;          //comm stuff
  char infile[30];

int main(int argc, char* argv[])    // make a command line set
{
  unsigned in, out;   // communications stuff
  char line[80];              // a buffer for stuff
  int cloop, working;        // a eye on the buffer, and CPI ctrl                         (current program instruction)
  int backup;               // line manager
  FILE *iofile;             // a file handle to use for stuff


  line[0] = '\0';             // init stuff
  ctr = 0;
  working = _command;


  _bios_serialcom(_COM_INIT, COM4, SETTINGS);   // set up the com port
  cprintf("Remote-o-prompt By Dan Williams");
  cprintf("Hit esc to exit");



  // interpret command line stuff

  if (argc < 1)
   printf("USE bla Com#, [Ssend file] [Rrecieve file] [Eexecute command]");
   printf("EG bla 4 smyfile.ext rauto.bat");
  if (argc == 2)
   printf("Waiting for remote commands");
  if (argc > 2)
   backup = argc;
  else
   backup = 0;




  while (working)        // the main loop
  {
    status = _bios_serialcom(_COM_STATUS, COM4, 0);


    if (status & DATA_READY)     // if stuff comming in
      if ((out = _bios_serialcom(_COM_RECEIVE, COM4, 0) & 0x7F) != 0)
       {


       if (backup == 0)
	if (working == _command)  // load instruction
	 {
	  if (out == 'd')  // dos command
	   working = 4;
	  if (out == 's')  // send file
	   {
	    M_open(0);
	    working = 3;
	   }
	  if (out == 'r')  // recieve file
	   {
	    M_open(1);
	    working = 2;
	   }
	  if ((out != 'd') && (out != 's') && (out != 'r'))
	   {
	    printf ("Remote command error %C", out);
	    working = 0;
	   }
	 }
	else //of backup == 0 (exec line commands)
	 {

	  if (argv[(argc-backup)+2][0]== 's')
	   {
	    // get the file name
	    if ((iofile = fopen(argv[(argc-backup)+2][1], "wb")) == NULL)
	     {
	      fprintf(stderr, "Cannot open file to output.\n");
              printf("%s", argv[(argc-backup)+2][1]);
	     }
            else
            {
	    // check the file length
            curpos = ftell(stream);
            fseek(stream, 0L, SEEK_END);
            length = ftell(stream);
            fseek(stream, curpos, SEEK_SET);
	    // send the filename
	    // send the filelength
	    working = 3;
            }
	    backup--;
	   }
	  if (argv[(argc-backup)+2][0]== 'r')  // will be sent filen 0 if err
	   {
	    // get the file name
	    // send request
	    // get the file length
	    working = 2;
	   }




	 }

	else
	if (working == _recieve)  // recieve
	 {
	 //
	 }
	else
	if (working == _send)  // send
	 {
	 //
	 }
	else
	if (working ==_exec)   // dos instruction
	 {
	 //
	 }
       }

  if (kbhit())         // end program
    {
      if (getch() == '\x1B')
	break;
    }


     // for sending datar
     // _bios_serialcom(_COM_SEND, COM4, in);




  }
  return 0;
}




FILE* M_open(int direction)
 {
  FILE *temp;
  char inn[30], tmpchr, sizes[30];
  int ctr;

   if (direction == 1)  // in
    {
     ctr = 0;                      // get the filename
     while (tmpchr != 0X0D);
       {
	status = _bios_serialcom(_COM_STATUS, COM4, 0);
	if (status & DATA_READY)
	 if ((tmpchr = _bios_serialcom(_COM_RECEIVE, COM4, 0) & 0x7F) != 0)
	  inn[ctr++] = tmpchr;
       }

     ctr = 0;                      // get the filesize
     while (tmpchr != 0X0D);
       {
	status = _bios_serialcom(_COM_STATUS, COM4, 0);
	if (status & DATA_READY)
	 if ((tmpchr = _bios_serialcom(_COM_RECEIVE, COM4, 0) & 0x7F) != 0)
	  sizes[ctr++] = tmpchr;
       }
      sizes[ctr++] = '\0';   // end of string protection
      fsize = atol(sizes);

      if ((temp = fopen(inn, "wb")) == NULL)
	{
	 fprintf(stderr, "Cannot open output file.\n");
	}

    }
   else                 // out
    {
      if ((temp = fopen(infile, "rb")) == NULL)
	{
	 fprintf(stderr, "Cannot open input file.\n");
	}



    }

   return(temp);
  }