/* Inverse kin for crs robot by DAn Williams */
#include <stdio.h>
#include "cwire.c"


#define BHlen  10   // Base height
#define UAlen  10   // Upper arm len
#define FAlen  10   // Forearm len
#define WRlen  2    // wrist len
#define Glen   4    // Gripper len

typedef struct
    {
      double x,y,z;     // otherwise 01, 02, 03
      double t1,t2,t3;  // otherwise 04, 05, 06
    } info;

void getinfo(info*);
void co_ord2angle(info*, info*);
void topulses(info*, info*);
int  isitin(info*);
double sqr(double);

int main(void)
   {
     info origional, angles, pulses;

      getinfo(& origional);
     if (isitin(& origional))
       {
         co_ord2angle(&origional, &angles);
         topulses(&angles, &pulses);
         printf (" X: %lf \n Y: %lf \n Z: %lf \n 1: %lf \n 2: %lf \n 3: %lf \n", angles.x, angles.y, angles.z, angles.t1, angles.t2, angles.t3);
         printf (" M1: %lf \n M2: %lf \n M3: %lf \n M4: %lf \n M5: %lf \n M6: %lf \n", pulses.x, pulses.y, pulses.z, pulses.t1, pulses.t2, pulses.t3);
       }
     else
       printf(" Out of my reach :-( ");

     return 0;
    }

 void getinfo(info* awnser)
  {
  double t;

     printf(" I'll trade you co-ordinates for anges!!! \n");
     printf(" What is the X position you would like \n");
     scanf("%f", &t);
     awnser->x = t;
     printf(" what is the y position you would like  \n");
     scanf("%f", &t);
     awnser->y = t;
     printf(" what is the z position you would like  \n");
     scanf("%f", &t);
     awnser->z = t;
     printf(" how much roll  \n");
     scanf("%f", &t);
     awnser->t1 = t;
     printf(" how much pitch you want \n");
     scanf("%f", &t);
     awnser->t2 = t;
     printf(" how much yaw \n");
     scanf("%f", &t);
     awnser->t3 = t;
  }


void co_ord2angle(info* co_ords, info* awnser)
   {
     double x,y,z;
     double b,rp;

     // fisrt work out where base of flange is
     // by translating desired point by reverse of original angle
     /*
     inittrans();                                 // initialize
     translate(-(WRlen+Glen),0,0);              //offset of tool(reversed)
     rotate(-(180-co_ords->t1), -(180-co_ords->t2), -(180-co_ords->t3));  // point back
     translate(co_ords->x, co_ords->y, co_ords->z);     // to the point
     x = matrix[3][0];                      // get the relivent data
     y = matrix[3][1];
     z = matrix[3][2];
     */
     x = co_ords->x;
     y = co_ords->y;
     z = co_ords->z;
             // now perform the normal math
     awnser->t1 = atan2l(y,x);

     rp = sqrtl(sqr(x)+sqr(y));
     b  = sqrtl(sqr(rp)+sqr(z-BHlen));

     awnser->t2 = acosl((sqr(UAlen)-sqr(FAlen)-sqr(b))/(-2*UAlen*b))+atanl((z-BHlen)/rp);
     awnser->t3 = -asinl((UAlen*sinl(awnser->t2)-(z-BHlen)/FAlen));

      // code goes here
     awnser->t1 *= 360/3.14159265;
     awnser->t2 *= 360/3.14159265;
     awnser->t3 *= 360/3.14159265;
     return ;
   }

void topulses(info* angles, info* awnser)
   {
    int spd;

    spd = 72000/360;
    awnser->x = spd * angles->x;
    awnser->y = spd * angles->y;
    awnser->z = spd * angles->z;
    awnser->t1 = spd * angles->t1;
    awnser->t2 = spd * angles->t2;
    awnser->t3 = spd * angles->t3;
    return;
   }

int isitin(info* co_ords)
   {
     int awnser;

     // code goes here

      return(1);
   }


double sqr(double in)
  {
    return(in * in);
  }