// remote-o-prompt by dan williams
/*

further ideas:
- a file to hold a list of instructions
- a 'wait for acknowledge' signal
*/
#include <bios.h>
//#include <dcomm.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>


#define DATA_READY 0x0100
#define TR_READY   0x4000
#define TRUE       1
#define FALSE      0
#define INFILE     2  // If a file is comming in

#define SETTINGS (_COM_2400 | _COM_CHR8 | _COM_STOP1 | _COM_NOPARITY)

#define _done    0   // EOP flag
#define _command 1   // load instruction
#define _recieve 2   // a recieve file
#define _send    3   // a send file
#define _exec    4   // dos command

/*
bla 4 sOCT.POV cPOVIT OCT 320.DEF  // with com 4 send oct.pov and do dos thing
bla 4 rOCT.TGA                     // with com 4 get oct.tga
*/


/* formats of stuff
command:
d(command line string)[0D]
file send:
s(name)(length)(file)
recieve file:
r(name)(length)(file)
*/

void sstring(char* string);
void schar(char);
char inchar(void);
FILE* M_open(int direction);
void update(void);


  long fsize;               // a file size variable
  unsigned status;          //comm stuff
  char infile[30];
  int flipper, currerr, COMP;


int main(int argc, char* argv[])    // make a command line set
{
  unsigned in, out;   // communications stuff
  char line[80];              // a buffer for stuff
  char string[25];
  int ctr, cloop, working;        // a eye on the buffer, and CPI ctrl                         (current program instruction)
  int backup;               // line manager
  FILE *iofile;             // a file handle to use for stuff
  long curpos, length, tmp;

  clrscr();
  line[0] = '\0';             // init stuff
  ctr = 0;
  working = _command;         // init for loop
  currerr= 0;




  printf("Remote-o-prompt By Dan Williams\n");
  printf("Hit esc to exit\n");



  // interpret command line stuff

  if (argc < 1)
  {
   printf("USE bla Com#, [Ssend file] [Rrecieve file] [Eexecute command]\n");
   printf("EG bla 4 smyfile.ext rauto.bat\n");
  }
  if (argc == 2)
   printf("Waiting for remote commands\n");
  if (argc > 2)
   backup = argc;
  else
   backup = 0;

  //sort out comm stuff

  COMP = atoi(argv[1])-1;
  _bios_serialcom(_COM_INIT, COMP, SETTINGS);
 // _init(COMP, 2400);   // set up the com port


  while (working)        // the main loop
  {
   status = _bios_serialcom(_COM_STATUS, COMP, 0);


   if ((backup == 2) && (argc > 2))
     break;



   if ((backup < 3)&&(working == _command))  // if no line commands
    {

     while (!((status = _bios_serialcom(_COM_STATUS, COMP, 0)) & DATA_READY))
	{
         gotoxy(3,4);
         printf("getting command from server               ");
         update();
	 if (kbhit())         // end program
	  {
	   if (getch() == '\x1B')
	   working = 0;     // exit program
	   break;
	  }
	}
     if (working == _done)
      return 0;
     out = _bios_serialcom(_COM_RECEIVE, COMP, 0) & 0X7F;


     if (out == 'd')  // dos command
      {

     ctr = 0;
     in = '\0';                      // get the command
     while (in != 0X0D)
       {
        update();
        gotoxy(3,4);
        printf("inputing remote dos command            ");
	status = _bios_serialcom(_COM_STATUS, COMP, 0);
	if (status & DATA_READY)
	 {
	  in = _bios_serialcom(_COM_RECEIVE, COMP, 0) & 0X7F;
	  line[ctr++] = in;
          gotoxy(9,1);
	 }
       }
       ctr--;
      line[ctr] = '\0';

      system(line);

   //   working = _exec;
      }



     if (out == 's')  // send file
      {
       iofile = M_open(0);
       if (currerr == 2)
        {
         schar('0');
         currerr = 0;
        }
       else
        {
         // det. file length
         curpos = ftell(iofile);
         fseek(iofile, 0L, SEEK_END);
         length = ftell(iofile);
         fseek(iofile, curpos, SEEK_SET);
         // send the filelength
         ltoa(length, string, 10);
         sstring(string);

         // send file
         for (tmp = 0; tmp < length; tmp++)
          {
           fread(&in, 1, 1, iofile);
           schar(in);
          }
         fclose (iofile);      //good thing to do.
        }
      }


     if (out == 'r')  // recieve file
      {
       iofile = M_open(1);

       if (currerr == 1)
        {
         gotoxy(1,8);
         printf("cannot open recieving file");
          for (tmp = 0; tmp <fsize; tmp++)
           inchar();  //dump the data to nowhere
         currerr = 0;
        }
       else
        {
         // send file
         for (tmp = 0; tmp < fsize; tmp++)
          {
           in = inchar();
           fprintf(iofile, "%c", in);
          }
         fclose (iofile);      //good thing to do.
        }
      // working = _recieve;
      }


     if ((out != 'd') && (out != 's') && (out != 'r'))
      {
       gotoxy (1,8);
       printf ("Remote command error %c", out);
       working = _done;
      }
    }



                // exec line commands



   if ((backup > 2)&&(working == _command))
    {
    gotoxy(3,4);
    printf("interperting line commands");

    if (argv[(argc-backup)+2][0]== 's')
     {


      // get the file name
      if ((iofile = fopen(&argv[(argc-backup)+2][1], "rb")) == NULL)
       {
        gotoxy (1,8);
        fprintf(stderr, "Cannot open file to output.\n");
       }
      else
       {
        printf("%s", &argv[(argc-backup)+2][1]);
        // send the command
        schar('r');
        // check the file length
        curpos = ftell(iofile);
        fseek(iofile, 0L, SEEK_END);
        length = ftell(iofile);
        fseek(iofile, curpos, SEEK_SET);
        // send the filename
        sstring(&argv[(argc-backup)+2][1]);
        // send the filelength
        schar(0X0D);
        ltoa(length, string, 10);
        sstring(string);
        schar(0X0D);
        // set the curr command flag

        for (tmp = 0; tmp < length; tmp++)
          {
           fread(&in, 1, 1, iofile);
           schar(in);
          }
         fclose (iofile);      //good thing to do.
        }
     // thats one less...
     backup--;
     }


     if (argv[(argc-backup)+2][0]== 'r')  // will be sent filelen 0 if err
      {

       if ((iofile = fopen(&argv[(argc-backup)+2][1], "wb")) == NULL)
       {
        gotoxy (1,8);
        fprintf(stderr, "Cannot open file to input.\n");
       }
      else
       {
       // send request
       schar('s');
       // send the filename
       sstring(&argv[(argc-backup)+2][1]);
       // get the file length

       schar(0X0D);

       while (in != 0X0D)
       {
        gotoxy(3,4);
        printf("inputing remote filesize             ");
	status = _bios_serialcom(_COM_STATUS, COMP, 0);
	if (status & DATA_READY)
	 {
	  in = _bios_serialcom(_COM_RECEIVE, COMP, 0)& 0X7F;
	  line[ctr++] = in;
	 }
       }
      ctr--;
      line[ctr] = '\0';
      length = atol(line);

       for (tmp = 0; tmp < length; tmp++)
          {
           in = inchar();
           fprintf(iofile, "%c",in);
          }
        fclose(iofile);
       }
       backup--;
      }

     if (argv[(argc-backup)+2][0]== 'd')
      {
        schar('d');
        sstring(&argv[(argc-backup)+2][1]);
        schar(0X0D);
       backup--;
      }


    }

  }

  return 0;
   }  //end of program













  void sstring(char* string)
   {
    int chrs;

    for (chrs = 0; chrs<strlen(string)+1; chrs ++)
     {
      while (!(_bios_serialcom(_COM_STATUS, COMP, 0) & TR_READY));
      _bios_serialcom(_COM_SEND, COMP, string[chrs]);
     }
   return;
   }


   void schar(char bla)
    {
      while (!(_bios_serialcom(_COM_STATUS, COMP, 0) & TR_READY));
      _bios_serialcom(_COM_SEND, COMP, bla);
      return;
    }


    char inchar(void)
     {
      unsigned status;
      char out;


      while (!((status = _bios_serialcom(_COM_STATUS, COMP, 0)) & DATA_READY))
	{
         gotoxy(3,4);
         printf("inputing remote character                    ");
	 if (kbhit())         // end program
	  {
	   if (getch() == '\x1B')
	   break;
	  }
	}
     out = _bios_serialcom(_COM_RECEIVE, COMP, 0) & 0X7F;

      return(out);
     }









  FILE* M_open(int direction)   // 0 = file to send
 {
  FILE *temp;
  char inn[30], tmpchr, sizes[30];
  int ctr;
  long curpos;

   if (direction == 1)  // in
    {
     ctr = 0;                      // get the filename
     while (tmpchr != 0X0D)
       {
        gotoxy(3,4);
        printf("inputing remote filename             ");
	status = _bios_serialcom(_COM_STATUS, COMP, 0);
	if (status & DATA_READY)
	 {
	  tmpchr = _bios_serialcom(_COM_RECEIVE, COMP, 0)& 0X7F;
	  inn[ctr++] = tmpchr;
	 }
       }
      ctr--;
      // end of string
      inn[ctr] = '\0';

     ctr = 0;
     // clear for loop
     tmpchr = '\0';             // get the filesize

     while (tmpchr != 0X0D)
       {
        gotoxy(3,4);
        printf("inputing remote filesize             ");
	status = _bios_serialcom(_COM_STATUS, COMP, 0);
	if (status & DATA_READY)
	 {
	  tmpchr = _bios_serialcom(_COM_RECEIVE, COMP, 0)& 0X7F;
	  sizes[ctr++] = tmpchr;
	 }
       }
      ctr--;
      sizes[ctr] = '\0';

      fsize = atol(sizes);

      if ((temp = fopen(inn, "wb")) == NULL)
	{
         gotoxy (1,8);
	 fprintf(stderr, "Cannot open output file.\n");
	 if ((temp = fopen("recover", "wb")) == NULL)
	  {
            gotoxy (1,8);
            fprintf(stderr, "Cannot open output recover file.\n");
            currerr = 1;
	  }
	}

    }
   else                 // out
    {

      ctr = 0;                      // get the filename
     while (tmpchr != 0X0D)
       {
        gotoxy(3,4);
        printf("inputing remote filename to bring in            ");
	status = _bios_serialcom(_COM_STATUS, COMP, 0);
	if (status & DATA_READY)
	 {
	  tmpchr = _bios_serialcom(_COM_RECEIVE, COMP, 0)& 0X7F;
	  inn[ctr++] = tmpchr;
          gotoxy(9,1);
          printf("%s", inn);
	 }
       }
       ctr--;
      inn[ctr] = '\0';
     ctr = 0;


      if ((temp = fopen(inn, "rb")) == NULL)
	{
         gotoxy (1,8);
	 fprintf(stderr, "Cannot open input file.\n            ");
         currerr = 2;
	}


    }

   return(temp);
  }


  void update(void)
   {
    char* stuff;
    char curchar;

    stuff = "-\|/";

    if (flipper > 3)
     flipper = 0;
    curchar = stuff[flipper++];
    gotoxy(3,5);
    printf("%c",curchar);

    return;
   }